Index: /trunk/kernel/kern/rpc.h
===================================================================
--- /trunk/kernel/kern/rpc.h	(revision 656)
+++ /trunk/kernel/kern/rpc.h	(revision 657)
@@ -2,5 +2,5 @@
  * rpc.h - RPC (Remote Procedure Call) operations definition.
  *
- * Author  Alain Greiner (2016,2017,2018)
+ * Author  Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -68,30 +68,19 @@
     RPC_THREAD_USER_CREATE        = 6,
     RPC_THREAD_KERNEL_CREATE      = 7,
-    RPC_VFS_FS_UPDATE_DENTRY      = 8,
+    RPC_UNDEFINED_8               = 8,
     RPC_PROCESS_SIGACTION         = 9,
 
-    RPC_VFS_INODE_CREATE          = 10,
-    RPC_VFS_INODE_DESTROY         = 11,
-    RPC_VFS_DENTRY_CREATE         = 12,
-    RPC_VFS_DENTRY_DESTROY        = 13,
-    RPC_VFS_FILE_CREATE           = 14,
-    RPC_VFS_FILE_DESTROY          = 15,
-    RPC_VFS_FS_NEW_DENTRY         = 16,
-    RPC_VFS_FS_ADD_DENTRY         = 17,
-    RPC_VFS_FS_REMOVE_DENTRY      = 18,
-    RPC_VFS_INODE_LOAD_ALL_PAGES  = 19,
-
-    RPC_UNDEFINED_20              = 20,   //
-    RPC_UNDEFINED_21              = 21,   //
-    RPC_UNDEFINED_22              = 22,   // 
-    RPC_UNDEFINED_23              = 23,   //
-    RPC_MAPPER_SYNC               = 24,
-    RPC_VMM_RESIZE_VSEG           = 25,
-    RPC_VMM_REMOVE_VSEG           = 26,
-    RPC_VMM_CREATE_VSEG           = 27,
-    RPC_VMM_SET_COW               = 28,
-    RPC_UNDEFINED_29              = 29,   //
-
-    RPC_MAX_INDEX                 = 30,
+    RPC_UNDEFINED_10              = 10,   //
+    RPC_UNDEFINED_11              = 11,   //
+    RPC_UNDEFINED_12              = 12,   // 
+    RPC_UNDEFINED_13              = 13,   //
+    RPC_UNDEFINED_14              = 14,   //
+    RPC_VMM_RESIZE_VSEG           = 15,
+    RPC_VMM_REMOVE_VSEG           = 16,
+    RPC_VMM_CREATE_VSEG           = 17,
+    RPC_VMM_SET_COW               = 18,
+    RPC_UNDEFINED_19              = 19,   //
+
+    RPC_MAX_INDEX                 = 20,
 }
 rpc_index_t;
@@ -288,27 +277,12 @@
 
 /***********************************************************************************
- * [8] The RPC_VFS_FS_UPDATE_DENTRY allows a client thread to request a remote
- * cluster to update the <size> field of a directory entry in the mapper of a
- * remote directory inode, identified by the <inode> local pointer.
- * The target entry name is identified by the <dentry> local pointer. 
- ***********************************************************************************
- * @ cxy     : server cluster identifier.
- * @ inode   : [in] local pointer on remote directory inode.
- * @ dentry  : [in] local pointer on remote dentry.
- * @ size    : [in] new size value.
- * @ error   : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_fs_update_dentry_client( cxy_t                 cxy,
-                                      struct vfs_inode_s  * inode,
-                                      struct vfs_dentry_s * dentry,
-                                      uint32_t              size,
-                                      error_t             * error );
-
-void rpc_vfs_fs_update_dentry_server( xptr_t xp );
+ * [8] undefined
+ **********************************************************************************/
 
 /***********************************************************************************
  * [9] The RPC_PROCESS_SIGACTION allows a client thread to request a remote cluster
  * to execute a given sigaction, defined by the <action_type> for a given process,
- * identified by the <pid> argument.
+ * identified by the <pid> argument.  When this RPC is used in parallel mode,
+ * the rpc_process_sigaction_client() function is not used. 
  ***********************************************************************************
  * @ cxy     : server cluster identifier.
@@ -323,202 +297,25 @@
 
 /*********************************************************************************** 
- * [10] The RPC_VFS_INODE_CREATE creates an inode and the associated mapper in a
- * remote cluster. The parent dentry must have been previously created.
- * It returns an extended pointer on the created inode.
- ***********************************************************************************
- * @ cxy        :  server cluster identifier.
- * @ fs_type    : [in]  file system type.
- * @ inode_type : [in]  file system type.
- * @ attr       : [in]  inode attributes.
- * @ rights     : [in]  access rights
- * @ uid        : [in]  user ID
- * @ gid        : [in]  group ID
- * @ inode_xp   : [out] buffer for extended pointer on created inode.
- * @ error      : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_inode_create_client( cxy_t      cxy,
-                                  uint32_t   fs_type,
-                                  uint32_t   attr,    
-                                  uint32_t   rights,  
-                                  uint32_t   uid,
-                                  uint32_t   gid,
-                                  xptr_t   * inode_xp,
-                                  error_t  * error );
-
-void rpc_vfs_inode_create_server( xptr_t xp );
+ * [10] undefined
+ **********************************************************************************/
 
 /*********************************************************************************** 
- * [11] The RPC_VFS_INODE_DESTROY releases memory allocated for an inode descriptor
- * and for the associated mapper in a remote cluster. 
- ***********************************************************************************
- * @ cxy       :  server cluster identifier
- * @ inode     : [in]  local pointer on inode.
- **********************************************************************************/
-void rpc_vfs_inode_destroy_client( cxy_t                cxy,
-                                   struct vfs_inode_s * inode );
-
-void rpc_vfs_inode_destroy_server( xptr_t xp );
+ * [11] undefined
+ **********************************************************************************/
 
 /*********************************************************************************** 
- * [12] The RPC_VFS_DENTRY_CREATE creates a dentry in a remote cluster. 
- * It returns an extended pointer on the created dentry.
- ***********************************************************************************
- * @ cxy        :  server cluster identifier
- * @ type       : [in]  file system type.
- * @ name       : [in]  directory entry name.
- * @ dentry_xp  : [out] buffer for extended pointer on created dentry.
- * @ error      : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_dentry_create_client( cxy_t                  cxy,
-                                   uint32_t               type,
-                                   char                 * name,    
-                                   xptr_t               * dentry_xp,
-                                   error_t              * error );
-
-void rpc_vfs_dentry_create_server( xptr_t xp );
+ * [12] undefined                                                       
+ **********************************************************************************/
 
 /*********************************************************************************** 
- * [13] The RPC_VFS_DENTRY_DESTROY remove a denfry from the parent inode XHTAB,
- * and releases memory allocated for the dentry descriptor in a remote cluster. 
- ***********************************************************************************
- * @ cxy       :  server cluster identifier
- * @ dentry     : [in]  local pointer on dentry.
- **********************************************************************************/
-void rpc_vfs_dentry_destroy_client( cxy_t                 cxy,
-                                    struct vfs_dentry_s * dentry );
-
-void rpc_vfs_dentry_destroy_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [14] The RPC_VFS_FILE_CREATE creates a file descriptor in a remote cluster. 
- * It returns an extended pointer on the created file structure.
- ***********************************************************************************
- * @ cxy        :  server cluster identifier
- * @ inode      : [in]  local pointer on parent inode.
- * @ file_attr  : [in]  new file attributes.
- * @ file_xp    : [out] buffer for extended pointer on created file.
- * @ error      : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_file_create_client( cxy_t                  cxy,
-                                 struct vfs_inode_s   * inode,
-                                 uint32_t               file_attr,
-                                 xptr_t               * file_xp,
-                                 error_t              * error );
-
-void rpc_vfs_file_create_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [15] The RPC_VFS_FILE_DESTROY releases memory allocated for a file descriptor
- * in a remote cluster. 
- ***********************************************************************************
- * @ cxy       :  server cluster identifier
- * @ file       : [in]  local pointer on file.
- **********************************************************************************/
-void rpc_vfs_file_destroy_client( cxy_t               cxy,
-                                  struct vfs_file_s * file );
-
-void rpc_vfs_file_destroy_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [16] The RPC_VFS_FS_GET_DENTRY calls the vfs_fs_new_dentry()
- * function in a remote cluster containing a parent inode directory to scan the 
- * associated mapper, find a directory entry identified by its name, and update
- * both the - existing - child inode and dentry.
- ***********************************************************************************
- * @ cxy            : server cluster identifier
- * @ parent_inode   : [in]  local pointer on parent inode.
- * @ name           : [in]  local pointer on child name (in client cluster).
- * @ child_inode_xp : [in]  extended pointer on child inode (in another cluster).
- * @ error          : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_fs_new_dentry_client( cxy_t                cxy,
-                                   struct vfs_inode_s * parent_inode,
-                                   char               * name,
-                                   xptr_t               child_inode_xp,
-                                   error_t            * error );
-
-void rpc_vfs_fs_new_dentry_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [17] The RPC_VFS_FS_ADD_DENTRY calls the vfs_fs_add_dentry() function in a 
- * remote cluster containing a directory inode and mapper, to add a new dentry
- * in the mapper of this directory.
- ***********************************************************************************
- * @ cxy            : server cluster identifier
- * @ parent         : [in]  local pointer on directory inode.
- * @ dentry         : [in]  local pointer on dentry.
- * @ error          : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_fs_add_dentry_client( cxy_t,
-                                   struct vfs_inode_s  * parent,
-                                   struct vfs_dentry_s * dentry,
-                                   error_t             * error );
-
-void rpc_vfs_fs_add_dentry_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [18] The RPC_VFS_FS_REMOVE_DENTRY calls the vfs_fs_remove_dentry() function in a
- * remote cluster containing a directory inode and mapper, to remove a dentry from
- * the mapper of this directory.
- ***********************************************************************************
- * @ cxy            : server cluster identifier
- * @ parent         : [in]  local pointer on directory inode.
- * @ dentry         : [in]  local pointer on dentry.
- * @ error          : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_fs_remove_dentry_client( cxy_t,
-                                      struct vfs_inode_s  * parent,
-                                      struct vfs_dentry_s * dentry,
-                                      error_t             * error );
-
-void rpc_vfs_fs_remove_dentry_server( xptr_t xp );
-
-/***********************************************************************************
- * [19] The RPC_VFS_INODE_LOAD_ALL_PAGES calls the vfs_inode_load_all_pages()
- * function a remote cluster containing an inode to load all pages in the
- * associated mapper.  
- ***********************************************************************************
- * @ cxy     : server cluster identifier
- * @ inode   : [in]  local pointer on inode in server cluster.
- * @ error   : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_vfs_inode_load_all_pages_client( cxy_t                cxy,
-                                          struct vfs_inode_s * inode,
-                                          error_t            * error );
-
-void rpc_vfs_inode_load_all_pages_server( xptr_t xp );
-
-/***********************************************************************************
- * [20] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [21] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [22] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [23] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [24] The RPC_MAPPER_SYNC allows a client thread to synchronize on disk
- * all dirty pages of a remote mapper.
- ***********************************************************************************
- * @ cxy       : server cluster identifier.
- * @ mapper    : [in] local pointer on mapper in server cluster.
- * @ error       : [out] error status (0 if success).
- **********************************************************************************/
-void rpc_mapper_sync_client( cxy_t             cxy,
-                             struct mapper_s * mapper,
-                             error_t         * error );
-
-void rpc_mapper_sync_server( xptr_t xp );
-
-/***********************************************************************************
- * [25] The RPC_VMM_RESIZE_VSEG allows a client thread to request a remote cluster
+ * [13] undefined                                       
+ **********************************************************************************/
+
+/***********************************************************************************
+ * [14] undefined
+ **********************************************************************************/
+
+/***********************************************************************************
+ * [15] The RPC_VMM_RESIZE_VSEG allows a client thread to request a remote cluster
  * to resize a vseg identified by the <base> argument in a process descriptor
  * identified by the <pid> argument, as defined by the <new_base> and <new_size>
@@ -540,5 +337,5 @@
 
 /***********************************************************************************
- * [26] The RPC_VMM_REMOVE_VSEG allows a client thread  to request a remote cluster
+ * [16] The RPC_VMM_REMOVE_VSEG allows a client thread  to request a remote cluster
  * to delete a vseg identified by the <vaddr> argument in a process descriptor
  * identified by the <pid> argument.
@@ -556,5 +353,5 @@
 
 /***********************************************************************************
- * [27] The RPC_VMM_CREATE_VSEG allows a client thread to request the remote 
+ * [17] The RPC_VMM_CREATE_VSEG allows a client thread to request the remote 
  * reference cluster of a given process to allocate and register in the reference
  * process VMM a new vseg descriptor.
@@ -587,5 +384,5 @@
 
 /***********************************************************************************
- * [28] The RPC_VMM_SET_COW allows a client thread to request the remote reference
+ * [18] The RPC_VMM_SET_COW allows a client thread to request the remote reference
  * cluster to set the COW flag and reset the WRITABLE flag of all GPT entries for
  * the DATA, MMAP and REMOTE vsegs of process identified by the <process> argument.
@@ -602,5 +399,5 @@
 
 /***********************************************************************************
- * [29] undefined
+ * [19] undefined
  **********************************************************************************/
 
Index: /trunk/kernel/kern/socket.c
===================================================================
--- /trunk/kernel/kern/socket.c	(revision 657)
+++ /trunk/kernel/kern/socket.c	(revision 657)
@@ -0,0 +1,298 @@
+/*
+ * socket.c - socket API implementation.
+ *
+ * Authors  Alain Greiner   (2016,2017,2018,2019,2020)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <kernel_config.h>
+#include <hal_kernel_types.h>
+#include <hal_remote.h>
+#include <shared_socket.h>
+#include <process.h>
+#include <remote_buf.h>
+#include <printk.h>
+#include <kmem.h>
+#include <thread.h>
+#include <vfs.h>
+#include <socket.h>
+
+//////////////////////////////////////////////////////////////////////////////////////
+// Extern global variables
+//////////////////////////////////////////////////////////////////////////////////////
+
+extern chdev_directory_t  chdev_dir;         // allocated in kernel_init.c
+
+//////////////////////////////////////
+char * socket_cmd_str( uint32_t type )
+{
+    switch( type )
+    {
+        case SOCKET_TX_CONNECT  : return "CONNECT";
+        case SOCKET_TX_SEND     : return "SEND";
+        case SOCKET_TX_CLOSE    : return "CLOSE";
+
+        default:                return "undefined";
+    }
+}
+   
+/////////////////////////////////////////
+char * socket_state_str( uint32_t state )
+{
+    switch( state )
+    {
+        case UDP_STATE_UNBOUND    : return "UDP_UNBOUND";
+        case UDP_STATE_BOUND      : return "UDP_BOUND";
+        case UDP_STATE_CONNECT    : return "UDP_CONNECT";
+
+        case TCP_STATE_UNBOUND    : return "TCP_UNBOUND";
+        case TCP_STATE_BOUND      : return "TCP_BOUND";
+        case TCP_STATE_LISTEN     : return "TCP_LISTEN";
+        case TCP_STATE_SYN_SENT   : return "TCP_SYN_SENT";
+        case TCP_STATE_SYN_RCVD   : return "TCP_SYN_RCVD";
+        case TCP_STATE_ESTAB      : return "TCP_ESTAB";
+        case TCP_STATE_FIN_WAIT1  : return "TCP_FIN_WAIT1";
+        case TCP_STATE_FIN_WAIT2  : return "TCP_FIN_WAIT2";
+        case TCP_STATE_CLOSING    : return "TCP_CLOSING";
+        case TCP_STATE_TIME_WAIT  : return "TCP_TIME_WAIT";
+        case TCP_STATE_CLOSE_WAIT : return "TCP_CLOSE_WAIT";
+        case TCP_STATE_LAST_ACK   : return "TCP_LAST_ACK";
+
+        default:                    return "undefined";
+    }
+}
+
+///////////////////////////////////////
+error_t socket_create( cxy_t       cxy,
+                       uint32_t    domain,
+                       uint32_t    type,
+                       socket_t ** socket_ptr,
+                       uint32_t  * fdid_ptr )
+{
+    uint32_t    fdid;
+
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+    kmem_req_t     req;
+    socket_t     * socket;
+    vfs_file_t   * file;
+    uint32_t       state;
+    error_t        error;
+
+    // allocate memory for socket descriptor 
+    req.type   = KMEM_KCM;
+    req.order  = bits_log2( sizeof(socket_t) );
+    req.flags  = AF_ZERO;
+    socket     = kmem_remote_alloc( cxy , &req );
+
+    if( socket == NULL )
+    {
+        printk("\n[ERROR] in %s : cannot allocate socket descriptor / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        return -1;
+    }
+
+    // allocate memory for rx_buf buffer
+    error = remote_buf_create( XPTR( cxy , &socket->rx_buf ),
+                               NIC_RX_BUF_SIZE );
+
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot allocate rx_buf / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        req.type = KMEM_KCM;
+        req.ptr  = socket;
+        kmem_remote_free( cxy , &req );
+        return -1;
+    }
+
+    // allocate memory for r2tq queue 
+    error = remote_buf_create( XPTR( cxy , &socket->r2tq ),
+                               NIC_R2T_QUEUE_SIZE );
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot allocate R2T queue / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        remote_buf_destroy( XPTR( cxy , &socket->rx_buf ) );
+        req.type = KMEM_KCM;
+        req.ptr  = socket;
+        kmem_remote_free( cxy , &req );
+        return -1;
+    }
+
+    // allocate memory for crqq queue 
+    error = remote_buf_create( XPTR( cxy , &socket->crqq ),
+                               NIC_CRQ_QUEUE_SIZE * sizeof(sockaddr_t) );
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot allocate CRQ queue / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        remote_buf_destroy( XPTR( cxy , &socket->r2tq ) );
+        remote_buf_destroy( XPTR( cxy , &socket->rx_buf ) );
+        req.type = KMEM_KCM;
+        req.ptr  = socket;
+        kmem_remote_free( cxy , &req );
+        return -1;
+    }
+
+    //  allocate memory for file descriptor
+	req.type  = KMEM_KCM;
+	req.order = bits_log2( sizeof(vfs_file_t) );
+    req.flags = AF_ZERO;
+	file      = kmem_remote_alloc( cxy , &req );
+
+    if( file == NULL ) 
+    {
+        printk("\n[ERROR] in %s : cannot allocate file descriptor / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        remote_buf_destroy( XPTR( cxy , &socket->crqq ) );
+        remote_buf_destroy( XPTR( cxy , &socket->r2tq ) );
+        remote_buf_destroy( XPTR( cxy , &socket->rx_buf ) );
+        req.type = KMEM_KCM;
+        req.ptr  = socket;
+        kmem_remote_free( cxy , &req );
+        return -1;
+    }
+    
+    // get an fdid value, and register file descriptor in fd_array[]
+    error = process_fd_register( process->ref_xp,
+                                 XPTR( cxy , file ),
+                                 &fdid );
+    if ( error ) 
+    {
+        printk("\n[ERROR] in %s : cannot register file descriptor / thread[%x,%x]\n",
+        __FUNCTION__, process->pid, this->trdid );
+        req.type = KMEM_KCM;
+        req.ptr  = file;
+        kmem_free( &req );
+        remote_buf_destroy( XPTR( cxy , &socket->crqq ) );
+        remote_buf_destroy( XPTR( cxy , &socket->r2tq ) );
+        remote_buf_destroy( XPTR( cxy , &socket->rx_buf ) );
+        req.ptr  = socket;
+        kmem_free( &req );
+        return -1;
+    }
+    state = (type == SOCK_STREAM) ? TCP_STATE_UNBOUND : UDP_STATE_UNBOUND;
+
+    // initialise socket descriptor 
+    hal_remote_s32( XPTR( cxy , &socket->domain    ) , domain );
+    hal_remote_s32( XPTR( cxy , &socket->type      ) , type );
+    hal_remote_s32( XPTR( cxy , &socket->pid       ) , process->pid );
+    hal_remote_s32( XPTR( cxy , &socket->state     ) , state );
+    hal_remote_s64( XPTR( cxy , &socket->tx_client ) , XPTR_NULL );
+    hal_remote_s64( XPTR( cxy , &socket->rx_client ) , XPTR_NULL );
+
+    // initialize file descriptor 
+    hal_remote_s32( XPTR( cxy , &file->type        ) , INODE_TYPE_SOCK );
+    hal_remote_spt( XPTR( cxy , &file->socket      ) , socket );
+    hal_remote_s32( XPTR( cxy , &file->refcount    ) , 1 );
+
+    remote_rwlock_init( XPTR( cxy , &file->lock ) , LOCK_VFS_FILE );
+   
+    // return success
+    *socket_ptr = socket;
+    *fdid_ptr   = fdid;
+
+    return 0;
+
+}  // end socket_create
+
+////////////////////////////////////
+void socket_destroy( uint32_t fdid )
+{
+    uint32_t            type;
+    socket_t          * socket;
+    kmem_req_t          req;
+
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+    // get pointers on file descriptor
+    xptr_t       file_xp  = process_fd_get_xptr( process , fdid );
+    vfs_file_t * file     = GET_PTR( file_xp );
+    cxy_t        cxy      = GET_CXY( file_xp );
+
+    type   = hal_remote_l32( XPTR( cxy , &file->type ) );
+    socket = hal_remote_lpt( XPTR( cxy , &file->socket ) );
+
+// check file descriptor pointer
+assert( (file_xp != XPTR_NULL), "illegal fdid\n" );
+
+// check file descriptor type
+assert( (type == INODE_TYPE_SOCK), "illegal file type\n" );
+
+    // remove the file descriptor from the process
+    process_fd_remove( process->owner_xp , fdid );
+
+    // release memory allocated for file descriptor
+    req.type = KMEM_KCM;
+    req.ptr  = file;
+    kmem_remote_free( cxy , &req );
+
+    // release memory allocated for buffers attached to socket descriptor
+    remote_buf_destroy( XPTR( cxy , &socket->crqq ) );
+    remote_buf_destroy( XPTR( cxy , &socket->r2tq ) );
+    remote_buf_destroy( XPTR( cxy , &socket->rx_buf ) );
+
+    // release memory allocated for socket descriptor
+    req.type = KMEM_KCM;
+    req.ptr  = socket;
+    kmem_remote_free( cxy , &req );
+
+}  // end socket_destroy()
+
+/////////////////////////////////////////////////
+void socket_link_to_servers( xptr_t    socket_xp,
+                             uint32_t  nic_channel ) 
+{
+    cxy_t      socket_cxy = GET_CXY( socket_xp );
+    socket_t * socket_ptr = GET_PTR( socket_xp );
+
+    // get pointers on NIC_TX[index] chdev
+    xptr_t    tx_chdev_xp  = chdev_dir.nic_tx[nic_channel];
+    chdev_t * tx_chdev_ptr = GET_PTR( tx_chdev_xp );
+    cxy_t     tx_chdev_cxy = GET_CXY( tx_chdev_xp );
+
+    // build extended pointers on root of sockets attached to NIC_TX[channel] chdev
+    xptr_t    tx_root_xp = XPTR( tx_chdev_cxy , &tx_chdev_ptr->wait_root );
+    xptr_t    tx_lock_xp = XPTR( tx_chdev_cxy , &tx_chdev_ptr->wait_lock );
+
+    // register socket in the NIC_TX[channel] chdev clients queue
+    remote_rwlock_wr_acquire( tx_lock_xp );
+    xlist_add_last( tx_root_xp , XPTR( socket_cxy , &socket_ptr->tx_list ) );
+    remote_rwlock_wr_release( tx_lock_xp );
+
+    // get pointers on NIC_RX[index] chdev
+    xptr_t    rx_chdev_xp  = chdev_dir.nic_rx[nic_channel];
+    chdev_t * rx_chdev_ptr = GET_PTR( rx_chdev_xp );
+    cxy_t     rx_chdev_cxy = GET_CXY( rx_chdev_xp );
+
+    // build extended pointer on root of sockets attached to NIC_TX[channel] chdev
+    xptr_t    rx_root_xp = XPTR( rx_chdev_cxy , &rx_chdev_ptr->wait_root );
+    xptr_t    rx_lock_xp = XPTR( rx_chdev_cxy , &rx_chdev_ptr->wait_lock );
+
+    // register socket in the NIC_RX[channel] chdev clients queue
+    remote_rwlock_wr_acquire( rx_lock_xp );
+    xlist_add_last( rx_root_xp , XPTR( socket_cxy , &socket_ptr->rx_list ) );
+    remote_rwlock_wr_release( rx_lock_xp );
+
+}  // end socket_link_to_server()
+
+
